Status: Resolved Priority: Should have
Author: Sebastian Michaelsen Category: Backend API
Created: 2012-12-11 Assigned To:
Updated: 2013-01-24 Due date:
TYPO3 Version: 6.0
PHP Version:
Complexity: easy
Is Regression:
Sprint Focus:
Subject: array_merge_recursive_overrule: __UNSET can't unset array values
Description

If the $enableUnsetFeature parameter is true, array_merge_recursive_overrule you can unset values from the first array.
The phpDoc says:

* @param boolean $enableUnsetFeature If set, special values "__UNSET" can be used in the second array in order to unset
array keys in the resulting array.

But in fact keys are only unset if they don't hold an array value. I see no reason why this should be like this. There should be the
possibility to unset array values.

Related issues:
related to Core - Feature # 33941: Add possibility to unset parts in t3lib_di... Resolved 2012-02-15

Associated revisions
Revision c0defbe7 - 2013-01-14 20:10 - Sebastian Michaelsen

[BUGFIX] array_merge_recursive_overrule: __UNSET for array values

Using __UNSET on keys that hold array values does not unset them.
However the documentation does not mention this restriction.
Therefore this is considered a bug and fixed by this patch.

Resolves: #43874
Releases: 6.1, 6.0, 4.7

Change-Id: Ie9f96c6f608da7e91fec2bc639dba9f3bcc8f426
Reviewed-on: https://review.typo3.org/17096
Reviewed-by: Markus Klein
Reviewed-by: Wouter Wolters
Reviewed-by: Tobias Liebig
Tested-by: Tobias Liebig

Revision 2e3ad694 - 2013-01-17 08:25 - Sebastian Michaelsen

[BUGFIX] array_merge_recursive_overrule: __UNSET for array values

Using __UNSET on keys that hold array values does not unset them.

2015-08-04 1/3

https://review.typo3.org/17096


However the documentation does not mention this restriction.
Therefore this is considered a bug and fixed by this patch.

Resolves: #43874
Releases: 6.1, 6.0, 4.7

Change-Id: Ie9f96c6f608da7e91fec2bc639dba9f3bcc8f426
Reviewed-on: https://review.typo3.org/17529
Reviewed-by: Markus Klein
Reviewed-by: Sebastian Michaelsen
Tested-by: Sebastian Michaelsen
Reviewed-by: Tobias Liebig
Tested-by: Tobias Liebig

Revision 04f83a85 - 2013-01-24 20:04 - Sebastian Michaelsen

[BUGFIX] array_merge_recursive_overrule: __UNSET for array values

Using __UNSET on keys that hold array values does not unset them.
However the documentation does not mention this restriction.
Therefore this is considered a bug and fixed by this patch.

Resolves: #43874
Releases: 6.1, 6.0, 4.7
Change-Id: Ie9f96c6f608da7e91fec2bc639dba9f3bcc8f426
Reviewed-on: https://review.typo3.org/17530
Reviewed-by: Wouter Wolters
Reviewed-by: Tobias Liebig
Tested-by: Tobias Liebig

History
#1 - 2012-12-11 12:30 - Markus Klein

Although this feature is not used in the Core at all, we can't change that behavior easily since this is public API.
Hence this would require a deprecation period of at least two versions first.

#2 - 2012-12-11 14:23 - Sebastian Michaelsen

I don't agree. It just changes the feature in a way to behave like it was documented.
It's very unlikely that someone used __UNSET on an array value which he doesn't want to be unset. So I don't expect anything to break.

#3 - 2012-12-13 16:28 - Tobias Liebig
- Category set to Backend API
- Complexity set to easy

#4 - 2012-12-13 16:29 - Tobias Liebig

I also think this change won't break anything.
#5 - 2013-01-14 20:30 - Sebastian Michaelsen
- Status changed from New to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:c0defbe74e3992b07dce859024d51544c4c7b9ed.

#6 - 2013-01-15 09:59 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/17529

#7 - 2013-01-15 10:07 - Gerrit Code Review

Patch set 3 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/17529

#8 - 2013-01-17 08:30 - Sebastian Michaelsen
- Status changed from Under Review to Resolved

Applied in changeset commit:2e3ad6942dc4b18471e377808e147098891f58c6.

#9 - 2013-01-23 11:11 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch TYPO3_4-7 has been pushed to the review server.
It is available at https://review.typo3.org/17530

#10 - 2013-01-24 20:30 - Sebastian Michaelsen
- Status changed from Under Review to Resolved

Applied in changeset commit:04f83a858f61921ce12a3a1948f557449d60f444.
